#if !defined(AFX_BUTTONTEXTURE_H__4F10FDCD_EF77_423F_8223_011704DFFED2__INCLUDED_)
#define AFX_BUTTONTEXTURE_H__4F10FDCD_EF77_423F_8223_011704DFFED2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

typedef vector<COLORREF>::iterator ColorRefIterator;

class ButtonTexture  
{
public:
	ButtonTexture(const string &name);
	virtual ~ButtonTexture();

	void configure(const string &name);
	void apply(HDC hDC, int x, int y, int width, int height, int buttonType);

	/*bool has_normalAlphaMap;
	bool has_activeAlphaMap;
	bool has_minimizedAlphaMap;
	bool has_flashingAlphaMap;*/

	int defaultAlpha;
	int normalAlpha;
	int activeAlpha;
	int minimizedAlpha;
	int flashingAlpha;

	int hoverAlpha;

private:

	void parseCFG(string cfg, COLORREF &bgcolor, COLORREF &lightcolor, COLORREF &darkcolor);
	void parseGradientCFG(string cfg, int imageType);
	void solidGradientPaint(HDC destHDC, vector<COLORREF> workGradient, RECT r, bool vertical);
	void paintEffects(HDC destHDC, int width, int height, int button_saturation, int button_hueIntensity, COLORREF button_hueColor );
	//void PrepareAlphaChannel(HBITMAP &bmp);

	vector<COLORREF> NormalGradient;
	vector<COLORREF> ActiveGradient;
	vector<COLORREF> MinimizedGradient;
	vector<COLORREF> FlashingGradient;

	vector<COLORREF> HoverGradient;

	HDC memoryNormalDC;
	HBITMAP memoryNormalBitmap;

	HDC memoryActiveDC;
	HBITMAP memoryActiveBitmap;

	HDC memoryMinimizedDC;
	HBITMAP memoryMinimizedBitmap;

	HDC memoryFlashingDC;
	HBITMAP memoryFlashingBitmap;

	HDC memoryHoverDC;
	HBITMAP memoryHoverBitmap;

	int imageNormalHeight;
	int imageNormalWidth;

	int imageActiveHeight;
	int imageActiveWidth;

	int imageMinimizedHeight;
	int imageMinimizedWidth;

	int imageFlashingHeight;
	int imageFlashingWidth;

	int imageHoverHeight;
	int imageHoverWidth;

	int defaultleftEdge;
	int defaulttopEdge;
	int defaultrightEdge;
	int defaultbottomEdge;

	int defaultmode;

	int normalleftEdge;
	int normaltopEdge;
	int normalrightEdge;
	int normalbottomEdge;

	int normalmode;

	int activeleftEdge;
	int activetopEdge;
	int activerightEdge;
	int activebottomEdge;

	int activemode;

	int minimizedleftEdge;
	int minimizedtopEdge;
	int minimizedrightEdge;
	int minimizedbottomEdge;

	int minimizedmode;

	int flashingleftEdge;
	int flashingtopEdge;
	int flashingrightEdge;
	int flashingbottomEdge;

	int flashingmode;

	int hoverleftEdge;
	int hovertopEdge;
	int hoverrightEdge;
	int hoverbottomEdge;

	int hovermode;

	int defaultbutton_saturation;
	int defaultbutton_hueIntensity;
	COLORREF defaultbutton_hueColor;

	int normalbutton_saturation;
	int normalbutton_hueIntensity;
	COLORREF normalbutton_hueColor;

	int activebutton_saturation;
	int activebutton_hueIntensity;
	COLORREF activebutton_hueColor;

	int minimizedbutton_saturation;
	int minimizedbutton_hueIntensity;
	COLORREF minimizedbutton_hueColor;

	int flashingbutton_saturation;
	int flashingbutton_hueIntensity;
	COLORREF flashingbutton_hueColor;

	int hoverbutton_saturation;
	int hoverbutton_hueIntensity;
	COLORREF hoverbutton_hueColor;

	string defaultsolidcolors;
	int defaultbevelSize;
	string defaultgradientColor;
	bool defaultverticalGradient;

	bool usenormalSolidColors;
	bool normalverticalGradient;
	int normalbevelSize;
	string normalgradientColor;
	COLORREF normalbackgroundColor;
	COLORREF normaldarkBevelColor;
	COLORREF normallightBevelColor;

	bool useactiveSolidColors;
	bool activeverticalGradient;
	int activebevelSize;
	COLORREF activebackgroundColor;
	COLORREF activedarkBevelColor;
	COLORREF activelightBevelColor;

	bool useminimizedSolidColors;
	bool minimizedverticalGradient;
	int minimizedbevelSize;
	COLORREF minimizedbackgroundColor;
	COLORREF minimizeddarkBevelColor;
	COLORREF minimizedlightBevelColor;

	bool useflashingSolidColors;
	bool flashingverticalGradient;
	int flashingbevelSize;
	COLORREF flashingbackgroundColor;
	COLORREF flashingdarkBevelColor;
	COLORREF flashinglightBevelColor;

	bool usehoverSolidColors;
	bool hoververticalGradient;
	int hoverbevelSize;
	COLORREF hoverbackgroundColor;
	COLORREF hoverdarkBevelColor;
	COLORREF hoverlightBevelColor;
};

#endif // !defined(AFX_BUTTONTEXTURE_H__4F10FDCD_EF77_423F_8223_011704DFFED2__INCLUDED_)
