#if !defined(AFX_TASKBARBUTTON_H__80A0FBD2_FB89_4557_822D_0E5BB681EC99__INCLUDED_)
#define AFX_TASKBARBUTTON_H__80A0FBD2_FB89_4557_822D_0E5BB681EC99__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

typedef list<HWND> hWndGroupList;
typedef list<HWND>::iterator hWndGroupListIterator;
 
class TaskbarButton  
{
	friend class Taskbar;

public:
	TaskbarButton( Taskbar *actualtaskbar, HWND hWnd );
	virtual ~TaskbarButton();

private:

	//Tray;
	//bool trayed;

	//Grouping
	hWndGroupList hwndgrouplist;

	void AddToGroup( HWND add_hTask )
	{
		hwndgrouplist.insert(hwndgrouplist.end(), add_hTask);
	}

	BOOL SearchInGroup( HWND search_hTask )
	{
		for(hWndGroupListIterator hglit = hwndgrouplist.begin(); hglit != hwndgrouplist.end(); hglit++)
		{
			if ( *hglit == search_hTask )
				return TRUE;
		}
		return FALSE;
	}

	void RemoveFromGroup( HWND remove_hTask )
	{
		for(hWndGroupListIterator hglit = hwndgrouplist.begin(); hglit != hwndgrouplist.end(); hglit++)
		{
			if ( (*hglit) == remove_hTask )
			{
				delete (*hglit);
				hwndgrouplist.erase( hglit );

				hButtonTask = (*hwndgrouplist.begin());
				break;
			}
		}
	}

	Taskbar *taskbar;

	HWND hButtonTask;
	string classname;

	// redraw == TRUE to force the button to update
	//			 FALSE to let the button decide whether to update or not
	BOOL onUpdate(bool needRedraw = FALSE);
	string GetWindowCaption( HWND check_hTask = NULL );
	HICON GetIcon();
	BOOL HasPoint( int xP, int yP );

	int currentState;
	int getCurrentState();

	HICON icon;
	string caption;
	string tooltip;

	bool useHover;

	int position;

	int buttonx;
	int buttony;
	int buttonwidth;
	int buttonheight;

	bool flashNow; //Start/Stop Flashing every Second

	void SetFlashing(bool flash)
	{
		flashNow = flash;
	}

	BOOL GetFlashing() const
	{
		return flashNow;
	}

	void onButtonClick( int x, int y, int action );	
	void Select();
	void Menu();

	void onPaint( HDC hDC );
	void setButtonLayout( int x, int y, int width, int height );
};

#endif // !defined(AFX_TASKBARBUTTON_H__80A0FBD2_FB89_4557_822D_0E5BB681EC99__INCLUDED_)
