#if !defined(AFX_UTILITIES_H__54F0E0FB_ABA1_4BDC_9F6B_8DF661DA0BD2__INCLUDED_)
#define AFX_UTILITIES_H__54F0E0FB_ABA1_4BDC_9F6B_8DF661DA0BD2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

const int MAX_INTEGER = 0x7FFFFFFF;
const int MIN_INTEGER = 0x80000000;

#define OS_9X   0x0001
#define OS_NT   0x0002
#define OS_95   0x0004
#define OS_98   0x0008
#define OS_ME   0x0010
#define OS_NT4  0x0020
#define OS_2K   0x0040
#define OS_XP   0x0080
#define OS_2KXP 0x0100

#define StringCchCopy(a, b, c) strncpy((a), (c), (b))
#define StringCchLength(a, b, c) *(c) = strlen((a)), S_OK
#define StringCchPrintf _snprintf

enum
{
	MULTIBLT_STRETCH,
	MULTIBLT_TILE,
	MULTIBLT_TILEHORIZONTAL,
	MULTIBLT_TILEVERTICAL
};

struct NameValuePair
{
	const char *name;
	int value;
};

string GetTaskClass( HWND hTask );

void PrefixedLSSetVariable(string prefix, string var, string value);

bool IsSubString(string big, string small);

bool IsOnTaskbarList(HWND hWnd, vector<string> theList, string taskbarname = "");

HICON GetTaskIcon(HWND hTask, bool bBigIcon);

HICON GetIconOnCustomList(HWND hWnd, vector<string> theList, bool bBigIcon);

bool IsOS(const int &os);

HWND GetLitestepDesktop();

bool IsAppWindow(const HWND &hWnd);

void ModifyStyle(HWND hWnd, DWORD removeStyle, DWORD addStyle);
void ModifyStyleEx(HWND hWnd, DWORD removeStyle, DWORD addStyle);

string trim(const string &toTrim);

void GetxRCList(char *text, vector<string> &theList);

bool GetxRCBool(const string &prefix, const string &baseName, bool defaultVal = false);

string GetxRCString(const string &prefix, const string &baseName, const string &defaultVal);

string GetxRCLine(const string &prefix, const string &baseName, const string &defaultVal);

int GetxRCNamedValue(const string &prefix, const string &baseName, const NameValuePair *nameValuePairs, int defaultVal);

int GetxRCColor(const string &prefix, const string &baseName, int defaultVal);

int GetxRCInt(const string &prefix, const string &baseName, int defaultVal, int minVal = MIN_INTEGER, int maxVal = MAX_INTEGER);

int xParseCoord(const string &aString, int defaultVal, int maxVal);
int GetxRCCoord(const string &prefix, const string &baseName, int defaultVal, int maxVal);

int xParseDimen(const string &aString, int defaultVal, int maxVal);
int GetxRCDimen(const string &prefix, const string &baseName, int defaultVal, int maxVal);

void PaintDesktopEx(HDC hdcDest, int xDest, int yDest, int cxDest, int cyDest, int xSrc, int ySrc, BOOL updateCache);

void TileBlt(HDC hdcDest, int xDest, int yDest, int cxDest, int cyDest, HDC hdcSrc, int xSrc, int ySrc, int cxSrc, int cySrc, DWORD rasterOp);
void HorizontalTileBlt(HDC hdcDest, int xDest, int yDest, int cxDest, int cyDest, HDC hdcSrc, int xSrc, int ySrc, int cxSrc, int cySrc, DWORD rasterOp);
void VerticalTileBlt(HDC hdcDest, int xDest, int yDest, int cxDest, int cyDest, HDC hdcSrc, int xSrc, int ySrc, int cxSrc, int cySrc, DWORD rasterOp);
void MultiBlt(HDC hdcDest, int xDest, int yDest, int cxDest, int cyDest, HDC hdcSrc, int xSrc, int ySrc, int cxSrc, int cySrc, int cxLeft, int cyTop, int cxRight, int cyBottom, int mode, DWORD rasterOp);

LPTSTR RegQueryStringValue(HKEY hKey, LPCTSTR pszSubKey, LPCTSTR pszValueName, LPTSTR pszBuffer, int nBufferSize, LPTSTR pszDefaultValue);

string IntToString(int input);

#endif // !defined(AFX_UTILITIES_H__54F0E0FB_ABA1_4BDC_9F6B_8DF661DA0BD2__INCLUDED_)
